grk::Precinct Struct Reference

`#include <Precinct.h>`

Inheritance diagram for grk::Precinct:

## Public Member Functions

| Precinct (TileProcessor *tileProcessor, const grk_rect32 &bounds, grk_pt32 cblk_expn)
virtual | ~Precinct ()
void | deleteTagTrees ()
grk_rect32 | getCodeBlockBounds (uint64_t cblkno)
TagTreeU16 * | getInclTree (void)
TagTreeU8 * | getImsbTree (void)
uint32_t | getCblkGridwidth (void)
uint32_t | getCblkGridHeight (void)
uint32_t | getNominalBlockSize (void)
uint64_t | getNumCblks (void)
CompressCodeblock * | getCompressedBlockPtr (uint64_t cblkno)
DecompressCodeblock * | getDecompressedBlockPtr (uint64_t cblkno)
DecompressCodeblock * | tryGetDecompressedBlockPtr (uint64_t cblkno)
grk_pt32 | getCblkExpn (void)
grk_rect32 | getCblkGrid (void)
Public Member Functions inherited from grk::grk_rect< uint32_t >
| grk_rect (uint32_t origin_x0, uint32_t origin_y0, uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (const grk_rect &rhs)
| grk_rect (const grk_rect *rhs)
| grk_rect (void)
virtual | ~grk_rect ()=default
grk_rect< uint32_t > & | setOrigin (uint32_t origx, uint32_t origy, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > &rhs, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > *rhs, bool absolute)
grk_rect< uint32_t > & | toRelative (void)
grk_rect< uint32_t > & | toAbsolute (void)
virtual void | print (void) const
std::string | boundsString () const
bool | valid (void) const
bool | empty (void) const
bool | contains (grk_pt< uint32_t > pt)
bool | contains (uint32_t x, uint32_t y)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > &rhs)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > *rhs)
bool | operator== (const grk_rect< uint32_t > &rhs) const
void | setRect (grk_rect< uint32_t > *rhs)
void | setRect (grk_rect< uint32_t > rhs)
grk_rect< uint32_t > | scaleDownCeil (uint32_t den) const
grk_rect< uint32_t > | scaleDownCeil (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scale (uint32_t scalex, uint32_t scaley) const
grk_rect< uint32_t > | scaleDown (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scaleDownPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | scaleDownPow2 (grk_pt< uint32_t > pow) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t power) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > *rhs) const
bool | isContainedIn (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > &rhs) const
grk_rect< uint32_t > & | clip_IN_PLACE (const grk_rect< uint32_t > &rhs)
bool | nonEmptyIntersection (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > &rhs) const
uint64_t | area (void) const
uint32_t | width () const
uint32_t | height () const
grk_line< uint32_t > | dimX () const
grk_line< uint32_t > | dimY () const
grk_rect< uint32_t > | pan (int64_t x, int64_t y) const
grk_rect< uint32_t > & | pan_IN_PLACE (int64_t x, int64_t y)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, grk_rect< uint32_t > bounds)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, grk_rect< uint32_t > bounds)
uint32_t | parityX (void) const
uint32_t | parityY (void) const

## Public Attributes

uint64_t | precinctIndex
uint16_t | numLayers_
Public Attributes inherited from grk::grk_rect< uint32_t >
bool | absoluteCoordinates
uint32_t | origin_x0
uint32_t | origin_y0
uint32_t | x0
uint32_t | y0
uint32_t | x1
uint32_t | y1

## Private Member Functions

PrecinctImpl * | getImpl (void)

## Private Attributes

PrecinctImpl * | impl
grk_pt32 | cblk_expn_

## Constructor & Destructor Documentation

## Precinct()

grk::Precinct::Precinct | ( | TileProcessor * | tileProcessor,
|  | const grk_rect32 & | bounds,
|  | grk_pt32 | cblk_expn
| ) |  |

## ~Precinct()

grk::Precinct::~Precinct | ( |  | ) |

virtual

References impl.

## Member Function Documentation

## deleteTagTrees()

void grk::Precinct::deleteTagTrees | ( |  | ) |

References grk::PrecinctImpl::deleteTagTrees(), and impl.

## getCblkExpn()

grk_pt32 grk::Precinct::getCblkExpn | ( | void |  | ) |

References cblk_expn_.

## getCblkGrid()

grk_rect32 grk::Precinct::getCblkGrid | ( | void |  | ) |

References grk::PrecinctImpl::cblk_grid_, and impl.

## getCblkGridHeight()

uint32_t grk::Precinct::getCblkGridHeight | ( | void |  | ) |

References grk::PrecinctImpl::cblk_grid_, grk::grk_rect< T >::height(), and impl.

## getCblkGridwidth()

uint32_t grk::Precinct::getCblkGridwidth | ( | void |  | ) |

References grk::PrecinctImpl::cblk_grid_, impl, and grk::grk_rect< T >::width().

## getCodeBlockBounds()

grk_rect32 grk::Precinct::getCodeBlockBounds | ( | uint64_t | cblkno | ) |

References grk::PrecinctImpl::getCodeBlockBounds(), and impl.

## getCompressedBlockPtr()

CompressCodeblock * grk::Precinct::getCompressedBlockPtr | ( | uint64_t | cblkno | ) |

References grk::PrecinctImpl::enc, and getImpl().

## getDecompressedBlockPtr()

DecompressCodeblock * grk::Precinct::getDecompressedBlockPtr | ( | uint64_t | cblkno | ) |

References grk::PrecinctImpl::dec, and getImpl().

Referenced by grk::TileProcessor::encodeT2(), and grk::PacketParser::readData().

## getImpl()

PrecinctImpl * grk::Precinct::getImpl | ( | void |  | ) |

inline private

References impl, grk::PrecinctImpl::initCodeBlocks(), and numLayers_.

Referenced by getCompressedBlockPtr(), getDecompressedBlockPtr(), and tryGetDecompressedBlockPtr().

## getImsbTree()

TagTreeU8 * grk::Precinct::getImsbTree | ( | void |  | ) |

References grk::PrecinctImpl::getIMsbTagTree(), and impl.

## getInclTree()

TagTreeU16 * grk::Precinct::getInclTree | ( | void |  | ) |

References grk::PrecinctImpl::getIncludeTagTree(), and impl.

## getNominalBlockSize()

uint32_t grk::Precinct::getNominalBlockSize | ( | void |  | ) |

References grk::PrecinctImpl::cblk_expn_, impl, grk::grk_pt< T >::x, and grk::grk_pt< T >::y.

## getNumCblks()

uint64_t grk::Precinct::getNumCblks | ( | void |  | ) |

References grk::grk_rect< T >::area(), grk::PrecinctImpl::cblk_grid_, and impl.

## tryGetDecompressedBlockPtr()

DecompressCodeblock * grk::Precinct::tryGetDecompressedBlockPtr | ( | uint64_t | cblkno | ) |

References grk::PrecinctImpl::dec, and getImpl().

## Member Data Documentation

## cblk_expn_

grk_pt32 grk::Precinct::cblk_expn_

private

Referenced by getCblkExpn().

## impl

PrecinctImpl* grk::Precinct::impl

private

Referenced by deleteTagTrees(), getCblkGrid(), getCblkGridHeight(), getCblkGridwidth(), getCodeBlockBounds(), getImpl(), getImsbTree(), getInclTree(), getNominalBlockSize(), getNumCblks(), and ~Precinct().

## numLayers_

uint16_t grk::Precinct::numLayers_

Referenced by getImpl().

## precinctIndex

uint64_t grk::Precinct::precinctIndex

The documentation for this struct was generated from the following files:

- Precinct.h
- Precinct.cpp